/*-
 * ~~~~~~licensing~~~~~~
 * connection-producing
 * ==========
 * Copyright (C) 2020 - 2025 EmDev LLC
 * ==========
 * You may not use this file except in accordance with the License Terms of the Copyright
 * Holder located at: https://entaxy.ru/eula . All copyrights, all intellectual property
 * rights to the Software and any copies are the property of the Copyright Holder. Unless
 * it is explicitly allowed the Copyright Holder, the User is prohibited from using the
 * Software for commercial purposes to provide services to third parties.
 * 
 * The Copyright Holder hereby declares that the Software is provided on an "AS IS".
 * Under no circumstances does the Copyright Holder guarantee or promise that the
 * Software provided by him will be suitable or not suitable for the specific purposes
 * of the User, that the Software will meet all commercial and personal subjective
 * expectations of the User, that the Software will work properly, without technical
 * errors, quickly and uninterruptedly.
 * 
 * Under no circumstances shall the Copyright Holder or its Affiliates is not liable
 * to the User for any direct or indirect losses of the User, his expenses or actual
 * damage, including, downtime; loss of bussines; lost profit; lost earnings; loss
 * or damage to data, property, etc.
 * ~~~~~~/licensing~~~~~~
 */
package ru.entaxy.platform.base.objects.connection.producing.adapters;

import java.net.URL;
import java.util.ArrayList;
import java.util.List;

import org.osgi.framework.ServiceRegistration;

import ru.entaxy.base.generator.template.Template;
import ru.entaxy.platform.base.objects.factory.EntaxyFactory;

public class TrackedAdapter {

	protected String id;
	protected long bundleId;
	protected String metadata;
	protected String configuration;
	protected ServiceRegistration<? extends EntaxyFactory> serviceRegistration;
	
	protected List<URL> templates = new ArrayList<>();
	protected List<ServiceRegistration<Template>> templateRegistrations = new ArrayList<>();;
	
	
	public void unregister() {
		try {
			this.serviceRegistration.unregister();
		} catch (Exception e) {
			
		};
		
		for (ServiceRegistration<Template> sr: templateRegistrations)
			try {
				sr.unregister();
			} catch (Exception e) {
				
			};
		
	}

	public String getId() {
		return id;
	}

	public void setId(String id) {
		this.id = id;
	}

	public long getBundleId() {
		return bundleId;
	}

	public void setBundleId(long bundleId) {
		this.bundleId = bundleId;
	}

	public String getConfiguration() {
		return configuration;
	}

	public void setConfiguration(String configuration) {
		this.configuration = configuration;
	}

	public String getMetadata() {
		return metadata;
	}

	public void setMetadata(String metadata) {
		this.metadata = metadata;
	}

	public ServiceRegistration<? extends EntaxyFactory> getServiceRegistration() {
		return serviceRegistration;
	}

	public void setServiceRegistration(ServiceRegistration<EntaxyFactory> serviceRegistration) {
		this.serviceRegistration = serviceRegistration;
	}

	public List<URL> getTemplates() {
		return templates;
	}

	public List<ServiceRegistration<Template>> getTemplateRegistrations() {
		return templateRegistrations;
	}
	
}
